#ifndef _H_8C55B8DD1AC7BDF18459BFCF70920187_BoolStamped_DCPS_H_
#define _H_8C55B8DD1AC7BDF18459BFCF70920187_BoolStamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BoolStamped_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BoolStamped_TypeSupportInterface;

            typedef BoolStamped_TypeSupportInterface * BoolStamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BoolStamped_TypeSupportInterface> BoolStamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BoolStamped_TypeSupportInterface> BoolStamped_TypeSupportInterface_out;


            class BoolStamped_DataWriter;

            typedef BoolStamped_DataWriter * BoolStamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BoolStamped_DataWriter> BoolStamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < BoolStamped_DataWriter> BoolStamped_DataWriter_out;


            class BoolStamped_DataReader;

            typedef BoolStamped_DataReader * BoolStamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BoolStamped_DataReader> BoolStamped_DataReader_var;
            typedef DDS_DCPSInterface_out < BoolStamped_DataReader> BoolStamped_DataReader_out;


            class BoolStamped_DataReaderView;

            typedef BoolStamped_DataReaderView * BoolStamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BoolStamped_DataReaderView> BoolStamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BoolStamped_DataReaderView> BoolStamped_DataReaderView_out;

            struct BoolStamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < BoolStamped_, struct BoolStamped_Seq_uniq_> BoolStamped_Seq;
            typedef DDS_DCPSSequence_var < BoolStamped_Seq> BoolStamped_Seq_var;
            typedef DDS_DCPSSequence_out < BoolStamped_Seq> BoolStamped_Seq_out;

            class  BoolStamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BoolStamped_TypeSupportInterface_ptr _ptr_type;
                typedef BoolStamped_TypeSupportInterface_var _var_type;

                static BoolStamped_TypeSupportInterface_ptr _duplicate (BoolStamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoolStamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BoolStamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoolStamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BoolStamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BoolStamped_TypeSupportInterface () {};
                ~BoolStamped_TypeSupportInterface () {};
            private:
                BoolStamped_TypeSupportInterface (const BoolStamped_TypeSupportInterface &);
                BoolStamped_TypeSupportInterface & operator = (const BoolStamped_TypeSupportInterface &);
            };

            class  BoolStamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BoolStamped_DataWriter_ptr _ptr_type;
                typedef BoolStamped_DataWriter_var _var_type;

                static BoolStamped_DataWriter_ptr _duplicate (BoolStamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoolStamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BoolStamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoolStamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BoolStamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BoolStamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BoolStamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BoolStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BoolStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BoolStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BoolStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BoolStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BoolStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BoolStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BoolStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BoolStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoolStamped_& instance_data) = 0;

            protected:
                BoolStamped_DataWriter () {};
                ~BoolStamped_DataWriter () {};
            private:
                BoolStamped_DataWriter (const BoolStamped_DataWriter &);
                BoolStamped_DataWriter & operator = (const BoolStamped_DataWriter &);
            };

            class  BoolStamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BoolStamped_DataReader_ptr _ptr_type;
                typedef BoolStamped_DataReader_var _var_type;

                static BoolStamped_DataReader_ptr _duplicate (BoolStamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoolStamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BoolStamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoolStamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BoolStamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BoolStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BoolStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BoolStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoolStamped_& instance) = 0;

            protected:
                BoolStamped_DataReader () {};
                ~BoolStamped_DataReader () {};
            private:
                BoolStamped_DataReader (const BoolStamped_DataReader &);
                BoolStamped_DataReader & operator = (const BoolStamped_DataReader &);
            };

            class  BoolStamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BoolStamped_DataReaderView_ptr _ptr_type;
                typedef BoolStamped_DataReaderView_var _var_type;

                static BoolStamped_DataReaderView_ptr _duplicate (BoolStamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoolStamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BoolStamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoolStamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BoolStamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BoolStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BoolStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BoolStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BoolStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoolStamped_& instance) = 0;

            protected:
                BoolStamped_DataReaderView () {};
                ~BoolStamped_DataReaderView () {};
            private:
                BoolStamped_DataReaderView (const BoolStamped_DataReaderView &);
                BoolStamped_DataReaderView & operator = (const BoolStamped_DataReaderView &);
            };
        }

    }

}

#endif
