#ifndef _H_DE419B9AC1F07ECBDBA4A03E2DF9C890_HealthStatus_DCPS_H_
#define _H_DE419B9AC1F07ECBDBA4A03E2DF9C890_HealthStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HealthStatus_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class HealthStatus_TypeSupportInterface;

            typedef HealthStatus_TypeSupportInterface * HealthStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HealthStatus_TypeSupportInterface> HealthStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HealthStatus_TypeSupportInterface> HealthStatus_TypeSupportInterface_out;


            class HealthStatus_DataWriter;

            typedef HealthStatus_DataWriter * HealthStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HealthStatus_DataWriter> HealthStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < HealthStatus_DataWriter> HealthStatus_DataWriter_out;


            class HealthStatus_DataReader;

            typedef HealthStatus_DataReader * HealthStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HealthStatus_DataReader> HealthStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < HealthStatus_DataReader> HealthStatus_DataReader_out;


            class HealthStatus_DataReaderView;

            typedef HealthStatus_DataReaderView * HealthStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HealthStatus_DataReaderView> HealthStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HealthStatus_DataReaderView> HealthStatus_DataReaderView_out;

            struct HealthStatus_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < HealthStatus_, struct HealthStatus_Seq_uniq_> HealthStatus_Seq;
            typedef DDS_DCPSSequence_var < HealthStatus_Seq> HealthStatus_Seq_var;
            typedef DDS_DCPSSequence_out < HealthStatus_Seq> HealthStatus_Seq_out;

            class  HealthStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HealthStatus_TypeSupportInterface_ptr _ptr_type;
                typedef HealthStatus_TypeSupportInterface_var _var_type;

                static HealthStatus_TypeSupportInterface_ptr _duplicate (HealthStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HealthStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HealthStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HealthStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HealthStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HealthStatus_TypeSupportInterface () {};
                ~HealthStatus_TypeSupportInterface () {};
            private:
                HealthStatus_TypeSupportInterface (const HealthStatus_TypeSupportInterface &);
                HealthStatus_TypeSupportInterface & operator = (const HealthStatus_TypeSupportInterface &);
            };

            class  HealthStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HealthStatus_DataWriter_ptr _ptr_type;
                typedef HealthStatus_DataWriter_var _var_type;

                static HealthStatus_DataWriter_ptr _duplicate (HealthStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HealthStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HealthStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HealthStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HealthStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HealthStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HealthStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HealthStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HealthStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HealthStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HealthStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HealthStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HealthStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HealthStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HealthStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HealthStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HealthStatus_& instance_data) = 0;

            protected:
                HealthStatus_DataWriter () {};
                ~HealthStatus_DataWriter () {};
            private:
                HealthStatus_DataWriter (const HealthStatus_DataWriter &);
                HealthStatus_DataWriter & operator = (const HealthStatus_DataWriter &);
            };

            class  HealthStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HealthStatus_DataReader_ptr _ptr_type;
                typedef HealthStatus_DataReader_var _var_type;

                static HealthStatus_DataReader_ptr _duplicate (HealthStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HealthStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HealthStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HealthStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HealthStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HealthStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HealthStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HealthStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HealthStatus_& instance) = 0;

            protected:
                HealthStatus_DataReader () {};
                ~HealthStatus_DataReader () {};
            private:
                HealthStatus_DataReader (const HealthStatus_DataReader &);
                HealthStatus_DataReader & operator = (const HealthStatus_DataReader &);
            };

            class  HealthStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HealthStatus_DataReaderView_ptr _ptr_type;
                typedef HealthStatus_DataReaderView_var _var_type;

                static HealthStatus_DataReaderView_ptr _duplicate (HealthStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HealthStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HealthStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HealthStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HealthStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HealthStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HealthStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HealthStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HealthStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HealthStatus_& instance) = 0;

            protected:
                HealthStatus_DataReaderView () {};
                ~HealthStatus_DataReaderView () {};
            private:
                HealthStatus_DataReaderView (const HealthStatus_DataReaderView &);
                HealthStatus_DataReaderView & operator = (const HealthStatus_DataReaderView &);
            };
        }

    }

}

#endif
