#ifndef _H_AF0DA567418E118A05E079A8C2BCA050_StringArrayStamped_DCPS_H_
#define _H_AF0DA567418E118A05E079A8C2BCA050_StringArrayStamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "StringArrayStamped_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class StringArrayStamped_TypeSupportInterface;

            typedef StringArrayStamped_TypeSupportInterface * StringArrayStamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < StringArrayStamped_TypeSupportInterface> StringArrayStamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < StringArrayStamped_TypeSupportInterface> StringArrayStamped_TypeSupportInterface_out;


            class StringArrayStamped_DataWriter;

            typedef StringArrayStamped_DataWriter * StringArrayStamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < StringArrayStamped_DataWriter> StringArrayStamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < StringArrayStamped_DataWriter> StringArrayStamped_DataWriter_out;


            class StringArrayStamped_DataReader;

            typedef StringArrayStamped_DataReader * StringArrayStamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < StringArrayStamped_DataReader> StringArrayStamped_DataReader_var;
            typedef DDS_DCPSInterface_out < StringArrayStamped_DataReader> StringArrayStamped_DataReader_out;


            class StringArrayStamped_DataReaderView;

            typedef StringArrayStamped_DataReaderView * StringArrayStamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < StringArrayStamped_DataReaderView> StringArrayStamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < StringArrayStamped_DataReaderView> StringArrayStamped_DataReaderView_out;

            struct StringArrayStamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < StringArrayStamped_, struct StringArrayStamped_Seq_uniq_> StringArrayStamped_Seq;
            typedef DDS_DCPSSequence_var < StringArrayStamped_Seq> StringArrayStamped_Seq_var;
            typedef DDS_DCPSSequence_out < StringArrayStamped_Seq> StringArrayStamped_Seq_out;

            class  StringArrayStamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef StringArrayStamped_TypeSupportInterface_ptr _ptr_type;
                typedef StringArrayStamped_TypeSupportInterface_var _var_type;

                static StringArrayStamped_TypeSupportInterface_ptr _duplicate (StringArrayStamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StringArrayStamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static StringArrayStamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StringArrayStamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                StringArrayStamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                StringArrayStamped_TypeSupportInterface () {};
                ~StringArrayStamped_TypeSupportInterface () {};
            private:
                StringArrayStamped_TypeSupportInterface (const StringArrayStamped_TypeSupportInterface &);
                StringArrayStamped_TypeSupportInterface & operator = (const StringArrayStamped_TypeSupportInterface &);
            };

            class  StringArrayStamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef StringArrayStamped_DataWriter_ptr _ptr_type;
                typedef StringArrayStamped_DataWriter_var _var_type;

                static StringArrayStamped_DataWriter_ptr _duplicate (StringArrayStamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StringArrayStamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static StringArrayStamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StringArrayStamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                StringArrayStamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const StringArrayStamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const StringArrayStamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const StringArrayStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const StringArrayStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const StringArrayStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const StringArrayStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const StringArrayStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const StringArrayStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const StringArrayStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const StringArrayStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (StringArrayStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StringArrayStamped_& instance_data) = 0;

            protected:
                StringArrayStamped_DataWriter () {};
                ~StringArrayStamped_DataWriter () {};
            private:
                StringArrayStamped_DataWriter (const StringArrayStamped_DataWriter &);
                StringArrayStamped_DataWriter & operator = (const StringArrayStamped_DataWriter &);
            };

            class  StringArrayStamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef StringArrayStamped_DataReader_ptr _ptr_type;
                typedef StringArrayStamped_DataReader_var _var_type;

                static StringArrayStamped_DataReader_ptr _duplicate (StringArrayStamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StringArrayStamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static StringArrayStamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StringArrayStamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                StringArrayStamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (StringArrayStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (StringArrayStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (StringArrayStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StringArrayStamped_& instance) = 0;

            protected:
                StringArrayStamped_DataReader () {};
                ~StringArrayStamped_DataReader () {};
            private:
                StringArrayStamped_DataReader (const StringArrayStamped_DataReader &);
                StringArrayStamped_DataReader & operator = (const StringArrayStamped_DataReader &);
            };

            class  StringArrayStamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef StringArrayStamped_DataReaderView_ptr _ptr_type;
                typedef StringArrayStamped_DataReaderView_var _var_type;

                static StringArrayStamped_DataReaderView_ptr _duplicate (StringArrayStamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StringArrayStamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static StringArrayStamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StringArrayStamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                StringArrayStamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (StringArrayStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (StringArrayStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (StringArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (StringArrayStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StringArrayStamped_& instance) = 0;

            protected:
                StringArrayStamped_DataReaderView () {};
                ~StringArrayStamped_DataReaderView () {};
            private:
                StringArrayStamped_DataReaderView (const StringArrayStamped_DataReaderView &);
                StringArrayStamped_DataReaderView & operator = (const StringArrayStamped_DataReaderView &);
            };
        }

    }

}

#endif
