#ifndef _H_DD18A75DB9581AA1726386D1481C2DAF_StringStamped_DCPS_H_
#define _H_DD18A75DB9581AA1726386D1481C2DAF_StringStamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "StringStamped_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class StringStamped_TypeSupportInterface;

            typedef StringStamped_TypeSupportInterface * StringStamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < StringStamped_TypeSupportInterface> StringStamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < StringStamped_TypeSupportInterface> StringStamped_TypeSupportInterface_out;


            class StringStamped_DataWriter;

            typedef StringStamped_DataWriter * StringStamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < StringStamped_DataWriter> StringStamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < StringStamped_DataWriter> StringStamped_DataWriter_out;


            class StringStamped_DataReader;

            typedef StringStamped_DataReader * StringStamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < StringStamped_DataReader> StringStamped_DataReader_var;
            typedef DDS_DCPSInterface_out < StringStamped_DataReader> StringStamped_DataReader_out;


            class StringStamped_DataReaderView;

            typedef StringStamped_DataReaderView * StringStamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < StringStamped_DataReaderView> StringStamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < StringStamped_DataReaderView> StringStamped_DataReaderView_out;

            struct StringStamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < StringStamped_, struct StringStamped_Seq_uniq_> StringStamped_Seq;
            typedef DDS_DCPSSequence_var < StringStamped_Seq> StringStamped_Seq_var;
            typedef DDS_DCPSSequence_out < StringStamped_Seq> StringStamped_Seq_out;

            class  StringStamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef StringStamped_TypeSupportInterface_ptr _ptr_type;
                typedef StringStamped_TypeSupportInterface_var _var_type;

                static StringStamped_TypeSupportInterface_ptr _duplicate (StringStamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StringStamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static StringStamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StringStamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                StringStamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                StringStamped_TypeSupportInterface () {};
                ~StringStamped_TypeSupportInterface () {};
            private:
                StringStamped_TypeSupportInterface (const StringStamped_TypeSupportInterface &);
                StringStamped_TypeSupportInterface & operator = (const StringStamped_TypeSupportInterface &);
            };

            class  StringStamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef StringStamped_DataWriter_ptr _ptr_type;
                typedef StringStamped_DataWriter_var _var_type;

                static StringStamped_DataWriter_ptr _duplicate (StringStamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StringStamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static StringStamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StringStamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                StringStamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const StringStamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const StringStamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const StringStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const StringStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const StringStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const StringStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const StringStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const StringStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const StringStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const StringStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (StringStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StringStamped_& instance_data) = 0;

            protected:
                StringStamped_DataWriter () {};
                ~StringStamped_DataWriter () {};
            private:
                StringStamped_DataWriter (const StringStamped_DataWriter &);
                StringStamped_DataWriter & operator = (const StringStamped_DataWriter &);
            };

            class  StringStamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef StringStamped_DataReader_ptr _ptr_type;
                typedef StringStamped_DataReader_var _var_type;

                static StringStamped_DataReader_ptr _duplicate (StringStamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StringStamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static StringStamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StringStamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                StringStamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (StringStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (StringStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (StringStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StringStamped_& instance) = 0;

            protected:
                StringStamped_DataReader () {};
                ~StringStamped_DataReader () {};
            private:
                StringStamped_DataReader (const StringStamped_DataReader &);
                StringStamped_DataReader & operator = (const StringStamped_DataReader &);
            };

            class  StringStamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef StringStamped_DataReaderView_ptr _ptr_type;
                typedef StringStamped_DataReaderView_var _var_type;

                static StringStamped_DataReaderView_ptr _duplicate (StringStamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StringStamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static StringStamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StringStamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                StringStamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (StringStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (StringStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (StringStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (StringStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StringStamped_& instance) = 0;

            protected:
                StringStamped_DataReaderView () {};
                ~StringStamped_DataReaderView () {};
            private:
                StringStamped_DataReaderView (const StringStamped_DataReaderView &);
                StringStamped_DataReaderView & operator = (const StringStamped_DataReaderView &);
            };
        }

    }

}

#endif
