#ifndef _H_890BAE0171DBD37143E7F6CBBA68A201_UInt32Stamped_DCPS_H_
#define _H_890BAE0171DBD37143E7F6CBBA68A201_UInt32Stamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UInt32Stamped_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class UInt32Stamped_TypeSupportInterface;

            typedef UInt32Stamped_TypeSupportInterface * UInt32Stamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UInt32Stamped_TypeSupportInterface> UInt32Stamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UInt32Stamped_TypeSupportInterface> UInt32Stamped_TypeSupportInterface_out;


            class UInt32Stamped_DataWriter;

            typedef UInt32Stamped_DataWriter * UInt32Stamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UInt32Stamped_DataWriter> UInt32Stamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < UInt32Stamped_DataWriter> UInt32Stamped_DataWriter_out;


            class UInt32Stamped_DataReader;

            typedef UInt32Stamped_DataReader * UInt32Stamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UInt32Stamped_DataReader> UInt32Stamped_DataReader_var;
            typedef DDS_DCPSInterface_out < UInt32Stamped_DataReader> UInt32Stamped_DataReader_out;


            class UInt32Stamped_DataReaderView;

            typedef UInt32Stamped_DataReaderView * UInt32Stamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UInt32Stamped_DataReaderView> UInt32Stamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UInt32Stamped_DataReaderView> UInt32Stamped_DataReaderView_out;

            struct UInt32Stamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UInt32Stamped_, struct UInt32Stamped_Seq_uniq_> UInt32Stamped_Seq;
            typedef DDS_DCPSSequence_var < UInt32Stamped_Seq> UInt32Stamped_Seq_var;
            typedef DDS_DCPSSequence_out < UInt32Stamped_Seq> UInt32Stamped_Seq_out;

            class  UInt32Stamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UInt32Stamped_TypeSupportInterface_ptr _ptr_type;
                typedef UInt32Stamped_TypeSupportInterface_var _var_type;

                static UInt32Stamped_TypeSupportInterface_ptr _duplicate (UInt32Stamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UInt32Stamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UInt32Stamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UInt32Stamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UInt32Stamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UInt32Stamped_TypeSupportInterface () {};
                ~UInt32Stamped_TypeSupportInterface () {};
            private:
                UInt32Stamped_TypeSupportInterface (const UInt32Stamped_TypeSupportInterface &);
                UInt32Stamped_TypeSupportInterface & operator = (const UInt32Stamped_TypeSupportInterface &);
            };

            class  UInt32Stamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UInt32Stamped_DataWriter_ptr _ptr_type;
                typedef UInt32Stamped_DataWriter_var _var_type;

                static UInt32Stamped_DataWriter_ptr _duplicate (UInt32Stamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UInt32Stamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UInt32Stamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UInt32Stamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UInt32Stamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UInt32Stamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UInt32Stamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UInt32Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UInt32Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UInt32Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UInt32Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UInt32Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UInt32Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UInt32Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UInt32Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UInt32Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UInt32Stamped_& instance_data) = 0;

            protected:
                UInt32Stamped_DataWriter () {};
                ~UInt32Stamped_DataWriter () {};
            private:
                UInt32Stamped_DataWriter (const UInt32Stamped_DataWriter &);
                UInt32Stamped_DataWriter & operator = (const UInt32Stamped_DataWriter &);
            };

            class  UInt32Stamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UInt32Stamped_DataReader_ptr _ptr_type;
                typedef UInt32Stamped_DataReader_var _var_type;

                static UInt32Stamped_DataReader_ptr _duplicate (UInt32Stamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UInt32Stamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UInt32Stamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UInt32Stamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UInt32Stamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UInt32Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UInt32Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UInt32Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UInt32Stamped_& instance) = 0;

            protected:
                UInt32Stamped_DataReader () {};
                ~UInt32Stamped_DataReader () {};
            private:
                UInt32Stamped_DataReader (const UInt32Stamped_DataReader &);
                UInt32Stamped_DataReader & operator = (const UInt32Stamped_DataReader &);
            };

            class  UInt32Stamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UInt32Stamped_DataReaderView_ptr _ptr_type;
                typedef UInt32Stamped_DataReaderView_var _var_type;

                static UInt32Stamped_DataReaderView_ptr _duplicate (UInt32Stamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UInt32Stamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UInt32Stamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UInt32Stamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UInt32Stamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UInt32Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UInt32Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UInt32Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UInt32Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UInt32Stamped_& instance) = 0;

            protected:
                UInt32Stamped_DataReaderView () {};
                ~UInt32Stamped_DataReaderView () {};
            private:
                UInt32Stamped_DataReaderView (const UInt32Stamped_DataReaderView &);
                UInt32Stamped_DataReaderView & operator = (const UInt32Stamped_DataReaderView &);
            };
        }

    }

}

#endif
