// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from marti_common_msgs:msg/StringArrayStamped.idl
// generated code does not contain a copyright notice

#ifndef MARTI_COMMON_MSGS__MSG__STRING_ARRAY_STAMPED__FUNCTIONS_H_
#define MARTI_COMMON_MSGS__MSG__STRING_ARRAY_STAMPED__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "marti_common_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "marti_common_msgs/msg/string_array_stamped__struct.h"

/// Initialize msg/StringArrayStamped message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * marti_common_msgs__msg__StringArrayStamped
 * )) before or use
 * marti_common_msgs__msg__StringArrayStamped__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
bool
marti_common_msgs__msg__StringArrayStamped__init(marti_common_msgs__msg__StringArrayStamped * msg);

/// Finalize msg/StringArrayStamped message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
void
marti_common_msgs__msg__StringArrayStamped__fini(marti_common_msgs__msg__StringArrayStamped * msg);

/// Create msg/StringArrayStamped message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * marti_common_msgs__msg__StringArrayStamped__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
marti_common_msgs__msg__StringArrayStamped *
marti_common_msgs__msg__StringArrayStamped__create();

/// Destroy msg/StringArrayStamped message.
/**
 * It calls
 * marti_common_msgs__msg__StringArrayStamped__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
void
marti_common_msgs__msg__StringArrayStamped__destroy(marti_common_msgs__msg__StringArrayStamped * msg);


/// Initialize array of msg/StringArrayStamped messages.
/**
 * It allocates the memory for the number of elements and calls
 * marti_common_msgs__msg__StringArrayStamped__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
bool
marti_common_msgs__msg__StringArrayStamped__Sequence__init(marti_common_msgs__msg__StringArrayStamped__Sequence * array, size_t size);

/// Finalize array of msg/StringArrayStamped messages.
/**
 * It calls
 * marti_common_msgs__msg__StringArrayStamped__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
void
marti_common_msgs__msg__StringArrayStamped__Sequence__fini(marti_common_msgs__msg__StringArrayStamped__Sequence * array);

/// Create array of msg/StringArrayStamped messages.
/**
 * It allocates the memory for the array and calls
 * marti_common_msgs__msg__StringArrayStamped__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
marti_common_msgs__msg__StringArrayStamped__Sequence *
marti_common_msgs__msg__StringArrayStamped__Sequence__create(size_t size);

/// Destroy array of msg/StringArrayStamped messages.
/**
 * It calls
 * marti_common_msgs__msg__StringArrayStamped__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_common_msgs
void
marti_common_msgs__msg__StringArrayStamped__Sequence__destroy(marti_common_msgs__msg__StringArrayStamped__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // MARTI_COMMON_MSGS__MSG__STRING_ARRAY_STAMPED__FUNCTIONS_H_
