#ifndef _H_5197B21C8B9FA0865723C21BC36F6DB0_ByteArrayStamped_DCPS_H_
#define _H_5197B21C8B9FA0865723C21BC36F6DB0_ByteArrayStamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ByteArrayStamped_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ByteArrayStamped_TypeSupportInterface;

            typedef ByteArrayStamped_TypeSupportInterface * ByteArrayStamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ByteArrayStamped_TypeSupportInterface> ByteArrayStamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ByteArrayStamped_TypeSupportInterface> ByteArrayStamped_TypeSupportInterface_out;


            class ByteArrayStamped_DataWriter;

            typedef ByteArrayStamped_DataWriter * ByteArrayStamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ByteArrayStamped_DataWriter> ByteArrayStamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < ByteArrayStamped_DataWriter> ByteArrayStamped_DataWriter_out;


            class ByteArrayStamped_DataReader;

            typedef ByteArrayStamped_DataReader * ByteArrayStamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ByteArrayStamped_DataReader> ByteArrayStamped_DataReader_var;
            typedef DDS_DCPSInterface_out < ByteArrayStamped_DataReader> ByteArrayStamped_DataReader_out;


            class ByteArrayStamped_DataReaderView;

            typedef ByteArrayStamped_DataReaderView * ByteArrayStamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ByteArrayStamped_DataReaderView> ByteArrayStamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ByteArrayStamped_DataReaderView> ByteArrayStamped_DataReaderView_out;

            struct ByteArrayStamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ByteArrayStamped_, struct ByteArrayStamped_Seq_uniq_> ByteArrayStamped_Seq;
            typedef DDS_DCPSSequence_var < ByteArrayStamped_Seq> ByteArrayStamped_Seq_var;
            typedef DDS_DCPSSequence_out < ByteArrayStamped_Seq> ByteArrayStamped_Seq_out;

            class  ByteArrayStamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ByteArrayStamped_TypeSupportInterface_ptr _ptr_type;
                typedef ByteArrayStamped_TypeSupportInterface_var _var_type;

                static ByteArrayStamped_TypeSupportInterface_ptr _duplicate (ByteArrayStamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ByteArrayStamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ByteArrayStamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ByteArrayStamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ByteArrayStamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ByteArrayStamped_TypeSupportInterface () {};
                ~ByteArrayStamped_TypeSupportInterface () {};
            private:
                ByteArrayStamped_TypeSupportInterface (const ByteArrayStamped_TypeSupportInterface &);
                ByteArrayStamped_TypeSupportInterface & operator = (const ByteArrayStamped_TypeSupportInterface &);
            };

            class  ByteArrayStamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ByteArrayStamped_DataWriter_ptr _ptr_type;
                typedef ByteArrayStamped_DataWriter_var _var_type;

                static ByteArrayStamped_DataWriter_ptr _duplicate (ByteArrayStamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ByteArrayStamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ByteArrayStamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ByteArrayStamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ByteArrayStamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ByteArrayStamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ByteArrayStamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ByteArrayStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ByteArrayStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ByteArrayStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ByteArrayStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ByteArrayStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ByteArrayStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ByteArrayStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ByteArrayStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ByteArrayStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ByteArrayStamped_& instance_data) = 0;

            protected:
                ByteArrayStamped_DataWriter () {};
                ~ByteArrayStamped_DataWriter () {};
            private:
                ByteArrayStamped_DataWriter (const ByteArrayStamped_DataWriter &);
                ByteArrayStamped_DataWriter & operator = (const ByteArrayStamped_DataWriter &);
            };

            class  ByteArrayStamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ByteArrayStamped_DataReader_ptr _ptr_type;
                typedef ByteArrayStamped_DataReader_var _var_type;

                static ByteArrayStamped_DataReader_ptr _duplicate (ByteArrayStamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ByteArrayStamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ByteArrayStamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ByteArrayStamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ByteArrayStamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ByteArrayStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ByteArrayStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ByteArrayStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ByteArrayStamped_& instance) = 0;

            protected:
                ByteArrayStamped_DataReader () {};
                ~ByteArrayStamped_DataReader () {};
            private:
                ByteArrayStamped_DataReader (const ByteArrayStamped_DataReader &);
                ByteArrayStamped_DataReader & operator = (const ByteArrayStamped_DataReader &);
            };

            class  ByteArrayStamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ByteArrayStamped_DataReaderView_ptr _ptr_type;
                typedef ByteArrayStamped_DataReaderView_var _var_type;

                static ByteArrayStamped_DataReaderView_ptr _duplicate (ByteArrayStamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ByteArrayStamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ByteArrayStamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ByteArrayStamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ByteArrayStamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ByteArrayStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ByteArrayStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ByteArrayStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ByteArrayStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ByteArrayStamped_& instance) = 0;

            protected:
                ByteArrayStamped_DataReaderView () {};
                ~ByteArrayStamped_DataReaderView () {};
            private:
                ByteArrayStamped_DataReaderView (const ByteArrayStamped_DataReaderView &);
                ByteArrayStamped_DataReaderView & operator = (const ByteArrayStamped_DataReaderView &);
            };
        }

    }

}

#endif
