#ifndef _H_E6F24CC1A8AD9192A9EFAFD84D8BFDB3_DurationStamped_DCPS_H_
#define _H_E6F24CC1A8AD9192A9EFAFD84D8BFDB3_DurationStamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DurationStamped_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DurationStamped_TypeSupportInterface;

            typedef DurationStamped_TypeSupportInterface * DurationStamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DurationStamped_TypeSupportInterface> DurationStamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DurationStamped_TypeSupportInterface> DurationStamped_TypeSupportInterface_out;


            class DurationStamped_DataWriter;

            typedef DurationStamped_DataWriter * DurationStamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DurationStamped_DataWriter> DurationStamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < DurationStamped_DataWriter> DurationStamped_DataWriter_out;


            class DurationStamped_DataReader;

            typedef DurationStamped_DataReader * DurationStamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DurationStamped_DataReader> DurationStamped_DataReader_var;
            typedef DDS_DCPSInterface_out < DurationStamped_DataReader> DurationStamped_DataReader_out;


            class DurationStamped_DataReaderView;

            typedef DurationStamped_DataReaderView * DurationStamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DurationStamped_DataReaderView> DurationStamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DurationStamped_DataReaderView> DurationStamped_DataReaderView_out;

            struct DurationStamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DurationStamped_, struct DurationStamped_Seq_uniq_> DurationStamped_Seq;
            typedef DDS_DCPSSequence_var < DurationStamped_Seq> DurationStamped_Seq_var;
            typedef DDS_DCPSSequence_out < DurationStamped_Seq> DurationStamped_Seq_out;

            class  DurationStamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DurationStamped_TypeSupportInterface_ptr _ptr_type;
                typedef DurationStamped_TypeSupportInterface_var _var_type;

                static DurationStamped_TypeSupportInterface_ptr _duplicate (DurationStamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DurationStamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DurationStamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DurationStamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DurationStamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DurationStamped_TypeSupportInterface () {};
                ~DurationStamped_TypeSupportInterface () {};
            private:
                DurationStamped_TypeSupportInterface (const DurationStamped_TypeSupportInterface &);
                DurationStamped_TypeSupportInterface & operator = (const DurationStamped_TypeSupportInterface &);
            };

            class  DurationStamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DurationStamped_DataWriter_ptr _ptr_type;
                typedef DurationStamped_DataWriter_var _var_type;

                static DurationStamped_DataWriter_ptr _duplicate (DurationStamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DurationStamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DurationStamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DurationStamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DurationStamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DurationStamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DurationStamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DurationStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DurationStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DurationStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DurationStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DurationStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DurationStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DurationStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DurationStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DurationStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DurationStamped_& instance_data) = 0;

            protected:
                DurationStamped_DataWriter () {};
                ~DurationStamped_DataWriter () {};
            private:
                DurationStamped_DataWriter (const DurationStamped_DataWriter &);
                DurationStamped_DataWriter & operator = (const DurationStamped_DataWriter &);
            };

            class  DurationStamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DurationStamped_DataReader_ptr _ptr_type;
                typedef DurationStamped_DataReader_var _var_type;

                static DurationStamped_DataReader_ptr _duplicate (DurationStamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DurationStamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DurationStamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DurationStamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DurationStamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DurationStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DurationStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DurationStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DurationStamped_& instance) = 0;

            protected:
                DurationStamped_DataReader () {};
                ~DurationStamped_DataReader () {};
            private:
                DurationStamped_DataReader (const DurationStamped_DataReader &);
                DurationStamped_DataReader & operator = (const DurationStamped_DataReader &);
            };

            class  DurationStamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DurationStamped_DataReaderView_ptr _ptr_type;
                typedef DurationStamped_DataReaderView_var _var_type;

                static DurationStamped_DataReaderView_ptr _duplicate (DurationStamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DurationStamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DurationStamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DurationStamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DurationStamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DurationStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DurationStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DurationStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DurationStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DurationStamped_& instance) = 0;

            protected:
                DurationStamped_DataReaderView () {};
                ~DurationStamped_DataReaderView () {};
            private:
                DurationStamped_DataReaderView (const DurationStamped_DataReaderView &);
                DurationStamped_DataReaderView & operator = (const DurationStamped_DataReaderView &);
            };
        }

    }

}

#endif
