#ifndef _H_DE419B9AC1F07ECBDBA4A03E2DF9C890_HealthStatus__H_
#define _H_DE419B9AC1F07ECBDBA4A03E2DF9C890_HealthStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace HealthStatus_Constants
            {
                const ::DDS::Octet OK_ = 0;

                const ::DDS::Octet WARN_ = 1;

                const ::DDS::Octet ERROR_ = 2;

                const ::DDS::Octet STALE_ = 3;

            }

            struct  HealthStatus_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet status_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<HealthStatus_> HealthStatus__var;
            typedef DDS_DCPSStruct_out < HealthStatus_> HealthStatus__out;

        }

    }

}

#endif /* _H_DE419B9AC1F07ECBDBA4A03E2DF9C890_HealthStatus__H_ */
