#ifndef _H_CFC1A60A09CE343C9C65920B427AB16D_Int16Stamped_DCPS_H_
#define _H_CFC1A60A09CE343C9C65920B427AB16D_Int16Stamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Int16Stamped_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Int16Stamped_TypeSupportInterface;

            typedef Int16Stamped_TypeSupportInterface * Int16Stamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Int16Stamped_TypeSupportInterface> Int16Stamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Int16Stamped_TypeSupportInterface> Int16Stamped_TypeSupportInterface_out;


            class Int16Stamped_DataWriter;

            typedef Int16Stamped_DataWriter * Int16Stamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Int16Stamped_DataWriter> Int16Stamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < Int16Stamped_DataWriter> Int16Stamped_DataWriter_out;


            class Int16Stamped_DataReader;

            typedef Int16Stamped_DataReader * Int16Stamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Int16Stamped_DataReader> Int16Stamped_DataReader_var;
            typedef DDS_DCPSInterface_out < Int16Stamped_DataReader> Int16Stamped_DataReader_out;


            class Int16Stamped_DataReaderView;

            typedef Int16Stamped_DataReaderView * Int16Stamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Int16Stamped_DataReaderView> Int16Stamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Int16Stamped_DataReaderView> Int16Stamped_DataReaderView_out;

            struct Int16Stamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Int16Stamped_, struct Int16Stamped_Seq_uniq_> Int16Stamped_Seq;
            typedef DDS_DCPSSequence_var < Int16Stamped_Seq> Int16Stamped_Seq_var;
            typedef DDS_DCPSSequence_out < Int16Stamped_Seq> Int16Stamped_Seq_out;

            class  Int16Stamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Int16Stamped_TypeSupportInterface_ptr _ptr_type;
                typedef Int16Stamped_TypeSupportInterface_var _var_type;

                static Int16Stamped_TypeSupportInterface_ptr _duplicate (Int16Stamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Int16Stamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Int16Stamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Int16Stamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Int16Stamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Int16Stamped_TypeSupportInterface () {};
                ~Int16Stamped_TypeSupportInterface () {};
            private:
                Int16Stamped_TypeSupportInterface (const Int16Stamped_TypeSupportInterface &);
                Int16Stamped_TypeSupportInterface & operator = (const Int16Stamped_TypeSupportInterface &);
            };

            class  Int16Stamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Int16Stamped_DataWriter_ptr _ptr_type;
                typedef Int16Stamped_DataWriter_var _var_type;

                static Int16Stamped_DataWriter_ptr _duplicate (Int16Stamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Int16Stamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Int16Stamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Int16Stamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Int16Stamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Int16Stamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Int16Stamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Int16Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Int16Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Int16Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Int16Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Int16Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Int16Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Int16Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Int16Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Int16Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Int16Stamped_& instance_data) = 0;

            protected:
                Int16Stamped_DataWriter () {};
                ~Int16Stamped_DataWriter () {};
            private:
                Int16Stamped_DataWriter (const Int16Stamped_DataWriter &);
                Int16Stamped_DataWriter & operator = (const Int16Stamped_DataWriter &);
            };

            class  Int16Stamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Int16Stamped_DataReader_ptr _ptr_type;
                typedef Int16Stamped_DataReader_var _var_type;

                static Int16Stamped_DataReader_ptr _duplicate (Int16Stamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Int16Stamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Int16Stamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Int16Stamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Int16Stamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Int16Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Int16Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Int16Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Int16Stamped_& instance) = 0;

            protected:
                Int16Stamped_DataReader () {};
                ~Int16Stamped_DataReader () {};
            private:
                Int16Stamped_DataReader (const Int16Stamped_DataReader &);
                Int16Stamped_DataReader & operator = (const Int16Stamped_DataReader &);
            };

            class  Int16Stamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Int16Stamped_DataReaderView_ptr _ptr_type;
                typedef Int16Stamped_DataReaderView_var _var_type;

                static Int16Stamped_DataReaderView_ptr _duplicate (Int16Stamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Int16Stamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Int16Stamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Int16Stamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Int16Stamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Int16Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Int16Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Int16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Int16Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Int16Stamped_& instance) = 0;

            protected:
                Int16Stamped_DataReaderView () {};
                ~Int16Stamped_DataReaderView () {};
            private:
                Int16Stamped_DataReaderView (const Int16Stamped_DataReaderView &);
                Int16Stamped_DataReaderView & operator = (const Int16Stamped_DataReaderView &);
            };
        }

    }

}

#endif
