#ifndef _H_B45EA2811B2FA483C39EE0D2F46AA9B9_KeyValueArray_DCPS_H_
#define _H_B45EA2811B2FA483C39EE0D2F46AA9B9_KeyValueArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "KeyValueArray_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class KeyValueArray_TypeSupportInterface;

            typedef KeyValueArray_TypeSupportInterface * KeyValueArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < KeyValueArray_TypeSupportInterface> KeyValueArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < KeyValueArray_TypeSupportInterface> KeyValueArray_TypeSupportInterface_out;


            class KeyValueArray_DataWriter;

            typedef KeyValueArray_DataWriter * KeyValueArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < KeyValueArray_DataWriter> KeyValueArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < KeyValueArray_DataWriter> KeyValueArray_DataWriter_out;


            class KeyValueArray_DataReader;

            typedef KeyValueArray_DataReader * KeyValueArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < KeyValueArray_DataReader> KeyValueArray_DataReader_var;
            typedef DDS_DCPSInterface_out < KeyValueArray_DataReader> KeyValueArray_DataReader_out;


            class KeyValueArray_DataReaderView;

            typedef KeyValueArray_DataReaderView * KeyValueArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < KeyValueArray_DataReaderView> KeyValueArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < KeyValueArray_DataReaderView> KeyValueArray_DataReaderView_out;

            struct KeyValueArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < KeyValueArray_, struct KeyValueArray_Seq_uniq_> KeyValueArray_Seq;
            typedef DDS_DCPSSequence_var < KeyValueArray_Seq> KeyValueArray_Seq_var;
            typedef DDS_DCPSSequence_out < KeyValueArray_Seq> KeyValueArray_Seq_out;

            class  KeyValueArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef KeyValueArray_TypeSupportInterface_ptr _ptr_type;
                typedef KeyValueArray_TypeSupportInterface_var _var_type;

                static KeyValueArray_TypeSupportInterface_ptr _duplicate (KeyValueArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyValueArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static KeyValueArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyValueArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyValueArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                KeyValueArray_TypeSupportInterface () {};
                ~KeyValueArray_TypeSupportInterface () {};
            private:
                KeyValueArray_TypeSupportInterface (const KeyValueArray_TypeSupportInterface &);
                KeyValueArray_TypeSupportInterface & operator = (const KeyValueArray_TypeSupportInterface &);
            };

            class  KeyValueArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef KeyValueArray_DataWriter_ptr _ptr_type;
                typedef KeyValueArray_DataWriter_var _var_type;

                static KeyValueArray_DataWriter_ptr _duplicate (KeyValueArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyValueArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static KeyValueArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyValueArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyValueArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const KeyValueArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const KeyValueArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const KeyValueArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const KeyValueArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const KeyValueArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const KeyValueArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const KeyValueArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const KeyValueArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const KeyValueArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const KeyValueArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (KeyValueArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KeyValueArray_& instance_data) = 0;

            protected:
                KeyValueArray_DataWriter () {};
                ~KeyValueArray_DataWriter () {};
            private:
                KeyValueArray_DataWriter (const KeyValueArray_DataWriter &);
                KeyValueArray_DataWriter & operator = (const KeyValueArray_DataWriter &);
            };

            class  KeyValueArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef KeyValueArray_DataReader_ptr _ptr_type;
                typedef KeyValueArray_DataReader_var _var_type;

                static KeyValueArray_DataReader_ptr _duplicate (KeyValueArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyValueArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static KeyValueArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyValueArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyValueArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (KeyValueArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (KeyValueArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (KeyValueArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KeyValueArray_& instance) = 0;

            protected:
                KeyValueArray_DataReader () {};
                ~KeyValueArray_DataReader () {};
            private:
                KeyValueArray_DataReader (const KeyValueArray_DataReader &);
                KeyValueArray_DataReader & operator = (const KeyValueArray_DataReader &);
            };

            class  KeyValueArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef KeyValueArray_DataReaderView_ptr _ptr_type;
                typedef KeyValueArray_DataReaderView_var _var_type;

                static KeyValueArray_DataReaderView_ptr _duplicate (KeyValueArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyValueArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static KeyValueArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyValueArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyValueArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (KeyValueArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (KeyValueArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (KeyValueArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (KeyValueArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KeyValueArray_& instance) = 0;

            protected:
                KeyValueArray_DataReaderView () {};
                ~KeyValueArray_DataReaderView () {};
            private:
                KeyValueArray_DataReaderView (const KeyValueArray_DataReaderView &);
                KeyValueArray_DataReaderView & operator = (const KeyValueArray_DataReaderView &);
            };
        }

    }

}

#endif
