#ifndef _H_B7E50474249396B43F15E278A27F9098_Matrix3x3Stamped_DCPS_H_
#define _H_B7E50474249396B43F15E278A27F9098_Matrix3x3Stamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Matrix3x3Stamped_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Matrix3x3Stamped_TypeSupportInterface;

            typedef Matrix3x3Stamped_TypeSupportInterface * Matrix3x3Stamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Matrix3x3Stamped_TypeSupportInterface> Matrix3x3Stamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Matrix3x3Stamped_TypeSupportInterface> Matrix3x3Stamped_TypeSupportInterface_out;


            class Matrix3x3Stamped_DataWriter;

            typedef Matrix3x3Stamped_DataWriter * Matrix3x3Stamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Matrix3x3Stamped_DataWriter> Matrix3x3Stamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < Matrix3x3Stamped_DataWriter> Matrix3x3Stamped_DataWriter_out;


            class Matrix3x3Stamped_DataReader;

            typedef Matrix3x3Stamped_DataReader * Matrix3x3Stamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Matrix3x3Stamped_DataReader> Matrix3x3Stamped_DataReader_var;
            typedef DDS_DCPSInterface_out < Matrix3x3Stamped_DataReader> Matrix3x3Stamped_DataReader_out;


            class Matrix3x3Stamped_DataReaderView;

            typedef Matrix3x3Stamped_DataReaderView * Matrix3x3Stamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Matrix3x3Stamped_DataReaderView> Matrix3x3Stamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Matrix3x3Stamped_DataReaderView> Matrix3x3Stamped_DataReaderView_out;

            struct Matrix3x3Stamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Matrix3x3Stamped_, struct Matrix3x3Stamped_Seq_uniq_> Matrix3x3Stamped_Seq;
            typedef DDS_DCPSSequence_var < Matrix3x3Stamped_Seq> Matrix3x3Stamped_Seq_var;
            typedef DDS_DCPSSequence_out < Matrix3x3Stamped_Seq> Matrix3x3Stamped_Seq_out;

            class  Matrix3x3Stamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Matrix3x3Stamped_TypeSupportInterface_ptr _ptr_type;
                typedef Matrix3x3Stamped_TypeSupportInterface_var _var_type;

                static Matrix3x3Stamped_TypeSupportInterface_ptr _duplicate (Matrix3x3Stamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Matrix3x3Stamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Matrix3x3Stamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Matrix3x3Stamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Matrix3x3Stamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Matrix3x3Stamped_TypeSupportInterface () {};
                ~Matrix3x3Stamped_TypeSupportInterface () {};
            private:
                Matrix3x3Stamped_TypeSupportInterface (const Matrix3x3Stamped_TypeSupportInterface &);
                Matrix3x3Stamped_TypeSupportInterface & operator = (const Matrix3x3Stamped_TypeSupportInterface &);
            };

            class  Matrix3x3Stamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Matrix3x3Stamped_DataWriter_ptr _ptr_type;
                typedef Matrix3x3Stamped_DataWriter_var _var_type;

                static Matrix3x3Stamped_DataWriter_ptr _duplicate (Matrix3x3Stamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Matrix3x3Stamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Matrix3x3Stamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Matrix3x3Stamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Matrix3x3Stamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Matrix3x3Stamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Matrix3x3Stamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Matrix3x3Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Matrix3x3Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Matrix3x3Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Matrix3x3Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Matrix3x3Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Matrix3x3Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Matrix3x3Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Matrix3x3Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Matrix3x3Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Matrix3x3Stamped_& instance_data) = 0;

            protected:
                Matrix3x3Stamped_DataWriter () {};
                ~Matrix3x3Stamped_DataWriter () {};
            private:
                Matrix3x3Stamped_DataWriter (const Matrix3x3Stamped_DataWriter &);
                Matrix3x3Stamped_DataWriter & operator = (const Matrix3x3Stamped_DataWriter &);
            };

            class  Matrix3x3Stamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Matrix3x3Stamped_DataReader_ptr _ptr_type;
                typedef Matrix3x3Stamped_DataReader_var _var_type;

                static Matrix3x3Stamped_DataReader_ptr _duplicate (Matrix3x3Stamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Matrix3x3Stamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Matrix3x3Stamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Matrix3x3Stamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Matrix3x3Stamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Matrix3x3Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Matrix3x3Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Matrix3x3Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Matrix3x3Stamped_& instance) = 0;

            protected:
                Matrix3x3Stamped_DataReader () {};
                ~Matrix3x3Stamped_DataReader () {};
            private:
                Matrix3x3Stamped_DataReader (const Matrix3x3Stamped_DataReader &);
                Matrix3x3Stamped_DataReader & operator = (const Matrix3x3Stamped_DataReader &);
            };

            class  Matrix3x3Stamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Matrix3x3Stamped_DataReaderView_ptr _ptr_type;
                typedef Matrix3x3Stamped_DataReaderView_var _var_type;

                static Matrix3x3Stamped_DataReaderView_ptr _duplicate (Matrix3x3Stamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Matrix3x3Stamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Matrix3x3Stamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Matrix3x3Stamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Matrix3x3Stamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Matrix3x3Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Matrix3x3Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Matrix3x3Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Matrix3x3Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Matrix3x3Stamped_& instance) = 0;

            protected:
                Matrix3x3Stamped_DataReaderView () {};
                ~Matrix3x3Stamped_DataReaderView () {};
            private:
                Matrix3x3Stamped_DataReaderView (const Matrix3x3Stamped_DataReaderView &);
                Matrix3x3Stamped_DataReaderView & operator = (const Matrix3x3Stamped_DataReaderView &);
            };
        }

    }

}

#endif
