#ifndef _H_022779F13A5C6DD0DBC1E9B7E28B6014_ServiceHeader_DCPS_H_
#define _H_022779F13A5C6DD0DBC1E9B7E28B6014_ServiceHeader_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ServiceHeader_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ServiceHeader_TypeSupportInterface;

            typedef ServiceHeader_TypeSupportInterface * ServiceHeader_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceHeader_TypeSupportInterface> ServiceHeader_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceHeader_TypeSupportInterface> ServiceHeader_TypeSupportInterface_out;


            class ServiceHeader_DataWriter;

            typedef ServiceHeader_DataWriter * ServiceHeader_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceHeader_DataWriter> ServiceHeader_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceHeader_DataWriter> ServiceHeader_DataWriter_out;


            class ServiceHeader_DataReader;

            typedef ServiceHeader_DataReader * ServiceHeader_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceHeader_DataReader> ServiceHeader_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceHeader_DataReader> ServiceHeader_DataReader_out;


            class ServiceHeader_DataReaderView;

            typedef ServiceHeader_DataReaderView * ServiceHeader_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceHeader_DataReaderView> ServiceHeader_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceHeader_DataReaderView> ServiceHeader_DataReaderView_out;

            struct ServiceHeader_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceHeader_, struct ServiceHeader_Seq_uniq_> ServiceHeader_Seq;
            typedef DDS_DCPSSequence_var < ServiceHeader_Seq> ServiceHeader_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceHeader_Seq> ServiceHeader_Seq_out;

            class  ServiceHeader_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceHeader_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceHeader_TypeSupportInterface_var _var_type;

                static ServiceHeader_TypeSupportInterface_ptr _duplicate (ServiceHeader_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHeader_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHeader_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHeader_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHeader_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceHeader_TypeSupportInterface () {};
                ~ServiceHeader_TypeSupportInterface () {};
            private:
                ServiceHeader_TypeSupportInterface (const ServiceHeader_TypeSupportInterface &);
                ServiceHeader_TypeSupportInterface & operator = (const ServiceHeader_TypeSupportInterface &);
            };

            class  ServiceHeader_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceHeader_DataWriter_ptr _ptr_type;
                typedef ServiceHeader_DataWriter_var _var_type;

                static ServiceHeader_DataWriter_ptr _duplicate (ServiceHeader_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHeader_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHeader_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHeader_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHeader_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceHeader_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceHeader_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceHeader_& instance_data) = 0;

            protected:
                ServiceHeader_DataWriter () {};
                ~ServiceHeader_DataWriter () {};
            private:
                ServiceHeader_DataWriter (const ServiceHeader_DataWriter &);
                ServiceHeader_DataWriter & operator = (const ServiceHeader_DataWriter &);
            };

            class  ServiceHeader_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceHeader_DataReader_ptr _ptr_type;
                typedef ServiceHeader_DataReader_var _var_type;

                static ServiceHeader_DataReader_ptr _duplicate (ServiceHeader_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHeader_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHeader_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHeader_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHeader_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceHeader_& instance) = 0;

            protected:
                ServiceHeader_DataReader () {};
                ~ServiceHeader_DataReader () {};
            private:
                ServiceHeader_DataReader (const ServiceHeader_DataReader &);
                ServiceHeader_DataReader & operator = (const ServiceHeader_DataReader &);
            };

            class  ServiceHeader_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceHeader_DataReaderView_ptr _ptr_type;
                typedef ServiceHeader_DataReaderView_var _var_type;

                static ServiceHeader_DataReaderView_ptr _duplicate (ServiceHeader_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHeader_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHeader_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHeader_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHeader_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceHeader_& instance) = 0;

            protected:
                ServiceHeader_DataReaderView () {};
                ~ServiceHeader_DataReaderView () {};
            private:
                ServiceHeader_DataReaderView (const ServiceHeader_DataReaderView &);
                ServiceHeader_DataReaderView & operator = (const ServiceHeader_DataReaderView &);
            };
        }

    }

}

#endif
