#ifndef _H_200E7C5D98596C10D73CBC782815B9A9_UInt16Stamped_DCPS_H_
#define _H_200E7C5D98596C10D73CBC782815B9A9_UInt16Stamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UInt16Stamped_.h"


namespace marti_common_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class UInt16Stamped_TypeSupportInterface;

            typedef UInt16Stamped_TypeSupportInterface * UInt16Stamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UInt16Stamped_TypeSupportInterface> UInt16Stamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UInt16Stamped_TypeSupportInterface> UInt16Stamped_TypeSupportInterface_out;


            class UInt16Stamped_DataWriter;

            typedef UInt16Stamped_DataWriter * UInt16Stamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UInt16Stamped_DataWriter> UInt16Stamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < UInt16Stamped_DataWriter> UInt16Stamped_DataWriter_out;


            class UInt16Stamped_DataReader;

            typedef UInt16Stamped_DataReader * UInt16Stamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UInt16Stamped_DataReader> UInt16Stamped_DataReader_var;
            typedef DDS_DCPSInterface_out < UInt16Stamped_DataReader> UInt16Stamped_DataReader_out;


            class UInt16Stamped_DataReaderView;

            typedef UInt16Stamped_DataReaderView * UInt16Stamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UInt16Stamped_DataReaderView> UInt16Stamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UInt16Stamped_DataReaderView> UInt16Stamped_DataReaderView_out;

            struct UInt16Stamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UInt16Stamped_, struct UInt16Stamped_Seq_uniq_> UInt16Stamped_Seq;
            typedef DDS_DCPSSequence_var < UInt16Stamped_Seq> UInt16Stamped_Seq_var;
            typedef DDS_DCPSSequence_out < UInt16Stamped_Seq> UInt16Stamped_Seq_out;

            class  UInt16Stamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UInt16Stamped_TypeSupportInterface_ptr _ptr_type;
                typedef UInt16Stamped_TypeSupportInterface_var _var_type;

                static UInt16Stamped_TypeSupportInterface_ptr _duplicate (UInt16Stamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UInt16Stamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UInt16Stamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UInt16Stamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UInt16Stamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UInt16Stamped_TypeSupportInterface () {};
                ~UInt16Stamped_TypeSupportInterface () {};
            private:
                UInt16Stamped_TypeSupportInterface (const UInt16Stamped_TypeSupportInterface &);
                UInt16Stamped_TypeSupportInterface & operator = (const UInt16Stamped_TypeSupportInterface &);
            };

            class  UInt16Stamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UInt16Stamped_DataWriter_ptr _ptr_type;
                typedef UInt16Stamped_DataWriter_var _var_type;

                static UInt16Stamped_DataWriter_ptr _duplicate (UInt16Stamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UInt16Stamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UInt16Stamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UInt16Stamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UInt16Stamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UInt16Stamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UInt16Stamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UInt16Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UInt16Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UInt16Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UInt16Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UInt16Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UInt16Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UInt16Stamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UInt16Stamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UInt16Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UInt16Stamped_& instance_data) = 0;

            protected:
                UInt16Stamped_DataWriter () {};
                ~UInt16Stamped_DataWriter () {};
            private:
                UInt16Stamped_DataWriter (const UInt16Stamped_DataWriter &);
                UInt16Stamped_DataWriter & operator = (const UInt16Stamped_DataWriter &);
            };

            class  UInt16Stamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UInt16Stamped_DataReader_ptr _ptr_type;
                typedef UInt16Stamped_DataReader_var _var_type;

                static UInt16Stamped_DataReader_ptr _duplicate (UInt16Stamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UInt16Stamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UInt16Stamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UInt16Stamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UInt16Stamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UInt16Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UInt16Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UInt16Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UInt16Stamped_& instance) = 0;

            protected:
                UInt16Stamped_DataReader () {};
                ~UInt16Stamped_DataReader () {};
            private:
                UInt16Stamped_DataReader (const UInt16Stamped_DataReader &);
                UInt16Stamped_DataReader & operator = (const UInt16Stamped_DataReader &);
            };

            class  UInt16Stamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UInt16Stamped_DataReaderView_ptr _ptr_type;
                typedef UInt16Stamped_DataReaderView_var _var_type;

                static UInt16Stamped_DataReaderView_ptr _duplicate (UInt16Stamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UInt16Stamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UInt16Stamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UInt16Stamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UInt16Stamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UInt16Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UInt16Stamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UInt16Stamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UInt16Stamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UInt16Stamped_& instance) = 0;

            protected:
                UInt16Stamped_DataReaderView () {};
                ~UInt16Stamped_DataReaderView () {};
            private:
                UInt16Stamped_DataReaderView (const UInt16Stamped_DataReaderView &);
                UInt16Stamped_DataReaderView & operator = (const UInt16Stamped_DataReaderView &);
            };
        }

    }

}

#endif
